/** 
 *   test_ib_client: IAR Bus (IPC) - Testing and demo implementation
 *   (client side).
 *
 *   (c) Copyright 2004 Federico Bareilles <fede@iar.unlp.edu.ar>,
 *   Instituto Argentino de Radio Astronomia (IAR).
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the License, or (at your option) any later version.
 *     
 *   The author does NOT admit liability nor provide warranty for any
 *   of this software. This material is provided "AS-IS" in the hope
 *   that it may be useful for others.
 *
 **/

#include <stdio.h>
#include <unistd.h>
#include "iar_bus.h"
#include "socket_client.h"

//#define TEST_IP "127.0.0.1"
#define TEST_IP "163.10.4.180"
#define TEST_PORT 1100


int main(int argc, const char *argv[]) 
{
	IBFD *dc;
	int ret = 1;
	uint32_t data;
	int i;
	int bar = 0;
	struct ib_packet d;


	dc = ibus_client_connect(TEST_IP, TEST_PORT);
	//dc = ibus_client_connect_local("test");
	if(dc == NULL) {
		printf("Can't connect to server.\n");
		return -1;
	}

	if ( ibus_bcast_on( dc ) != 0 ) {
		printf("Can't start bus.\n");
		return -1;		
	}
	//data = (uint32_t *) d.data;
	__builtin_memcpy(&data, d.data, sizeof(uint32_t));
	data = i = 1;
	ibus_send_data( dc, &data, sizeof(uint32_t));
	while(ret > 0 && i < 10000){

		while( ! IBUS_IF_PACKET(dc) ){
			if(bar == 0) printf("-\r");
			else if(bar == 1)  printf("\\\r");
			else if(bar == 2)  printf("|\r");
			else if(bar == 3)  printf("/\r");
			bar++;
			bar %= 4;
		}
		printf("\r");

		ret = ibus_read(dc, &d);
		printf(" Addr: 0x%03x, len: %3d ret: %d, ", 
		       d.h.addr, d.h.size, ret);
		if( d.h.size > 0) {
			printf("%d %d\n", i, data);
			i++;
		}
		else 
			printf("\n");
		 
	}
	if(i == 10000){
		ibus_remove( dc );
		ibus_client_close(dc);
	}
	return 0;
}

